//+------------------------------------------------------------------+
//|                                                   std_simple.mq5 |
//|                                  Copyright 2021, MetaQuotes Ltd. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2021, MetaQuotes Ltd."
#property link      "https://www.mql5.com"
#property version   "1.00"
#include <MovingAverages.mqh>


#property indicator_chart_window
#property indicator_buffers 3
#property indicator_plots   1
//--- plot std_CO
#property indicator_label1  "std_CO"
#property indicator_type1   DRAW_LINE
#property indicator_color1  clrAqua
#property indicator_style1  STYLE_SOLID
#property indicator_width1  1
//--- indicator buffers
double         std_COBuffer[];
double         ma_coBuffer[];
double         C_OBuffer[];

input int periodo =30;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- indicator buffers mapping
   SetIndexBuffer(0,std_COBuffer,INDICATOR_DATA);
   SetIndexBuffer(0,ma_coBuffer,INDICATOR_CALCULATIONS);
   SetIndexBuffer(1,C_OBuffer,INDICATOR_CALCULATIONS);
   
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---
   for(int i=0;i<rates_total;i++)
     {
        
      C_OBuffer[i] = close[i]-open[i];
      if(i>periodo)
        {
          ma_coBuffer[i]=SimpleMA(i,periodo,C_OBuffer); // OK works normal.
        }
        
      }
      
    for(int i=0;i<rates_total;i++)
      {
         if(i>=periodo)
             {
                std_COBuffer[i] = StdDev_Func(i,C_OBuffer,ma_coBuffer,periodo); //array out of range??
             }
       }          
    
//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+
double StdDev_Func(const int position,const double &price[],const double &ma_price[],const int period)
  {
   double std_dev=0.0;
//--- calcualte StdDev
   if(position>=period)
     {
      for(int i=0; i<period; i++)
         std_dev+=MathPow(price[position-i]-ma_price[position],2.0);
      std_dev=MathSqrt(std_dev/(period-1));
     }
//--- return calculated value
   return(std_dev);
  }